<?php

namespace Drupal\content_snapshot\ContentProvider;

/**
 * Implements Class ContentProvider.
 */
class ContentProvider implements ContentProviderInterface {

  /**
   * The Content Provider Interface.
   *
   * @var \Drupal\content_snapshot\ContentProvider\ContentProviderInterface[]
   */
  private $providers = [];

  /**
   * Add a content provider to the chain of providers.
   *
   * @param \Drupal\content_snapshot\ContentProvider\ContentProviderInterface $provider
   *   The Content Provider Interface.
   */
  public function addProvider(ContentProviderInterface $provider) {
    $this->providers[] = $provider;
  }

  /**
   * {@inheritdoc}
   */
  public function provide(): array {
    $content = [];
    foreach ($this->providers as $provider) {
      $content = array_merge($content, $provider->provide());
    }

    return $content;
  }

}
