<?php

namespace Drupal\content_snapshot\ContentWriter;

/**
 * Chain of writers writing different types of objects to the database.
 */
class ContentWriterChain implements ContentWriterInterface {

  /**
   * Array writers.
   *
   * @var \Drupal\content_snapshot\ContentWriter\ContentWriterInterface[]
   */
  private $writers = [];

  /**
   * Add a writer to the chain.
   *
   * @param \Drupal\content_snapshot\ContentWriter\ContentWriterInterface $writer
   *   The content writer.
   */
  public function addWriter(ContentWriterInterface $writer) {
    $this->writers[] = $writer;
  }

  /**
   * {@inheritdoc}
   */
  public function write($object): bool {
    foreach ($this->writers as $writer) {
      if ($writer->write($object)) {
        return TRUE;
      }
    }

    return FALSE;
  }

}
