<?php

namespace Drupal\content_snapshot\Converter;

use Drupal\content_snapshot\Snapshot\SnapshotItemInterface;

/**
 * Chain converting snapshot items back into objects.
 */
class ToObjectConverterChain implements ToObjectConverterInterface {

  /**
   * Converters.
   *
   * @var \Drupal\content_snapshot\Converter\ToObjectConverterInterface[]
   */
  private $converters = [];

  /**
   * {@inheritdoc}
   */
  public function addConverter(ToObjectConverterInterface $converter): void {
    $this->converters[] = $converter;
  }

  /**
   * {@inheritdoc}
   */
  public function snapshotItemToObject(SnapshotItemInterface $snapshotItem) {
    foreach ($this->converters as $converter) {
      if ($result = $converter->snapshotItemToObject($snapshotItem)) {
        return $result;
      }
    }

    return NULL;
  }

}
