<?php

namespace Drupal\content_snapshot\Converter;

use Drupal\content_snapshot\Snapshot\SnapshotItemInterface;

/**
 * Interface for Snapshot Item Converter.
 */
interface ToSnapshotItemConverterInterface {

  /**
   * Converts array into snapshot item.
   *
   * @param array $content
   *   Content.
   *
   * @return \Drupal\content_snapshot\Snapshot\SnapshotItemInterface|null
   *   Returns SnapshotItemInterface.
   */
  public function arrayToSnapshot(array $content): ?SnapshotItemInterface;

  /**
   * Converts arbitrary object representing content into a snapshot item.
   *
   * @param string $object
   *   Object.
   *
   * @return \Drupal\content_snapshot\Snapshot\SnapshotItemInterface|null
   *   Returns SnapshotItemInterface.
   */
  public function objectToSnapshot($object): ?SnapshotItemInterface;

}
