<?php

namespace Drupal\content_snapshot\Purger;

/**
 * Implements Class Purger.
 */
class Purger implements PurgerInterface {

  /**
   * The Purgers.
   *
   * @var \Drupal\content_snapshot\Purger\PurgerInterface[]
   */
  private $purgers = [];

  /**
   * Add purger to the chain of purgers.
   *
   * @param \Drupal\content_snapshot\Purger\PurgerInterface $purger
   *   Purger to add to the chain.
   */
  public function addPurger(PurgerInterface $purger) {
    $this->purgers[] = $purger;
  }

  /**
   * {@inheritdoc}
   */
  public function purge(): void {
    foreach ($this->purgers as $purger) {
      $purger->purge();
    }
  }

}
