<?php

namespace Drupal\content_snapshot\ReferenceRestorer;

use Drupal\content_snapshot\Snapshot\SnapshotItemInterface;

/**
 * Reference restorer specification.
 *
 * The role of reference restorer is to restore dependencies between content
 * items.
 */
interface ReferenceRestorerInterface {

  public const RESTORING_REFERENCES_CONTEXT = 'content_snapshot.restoring_references';

  /**
   * Restore object's references.
   *
   * @param \Drupal\content_snapshot\Snapshot\SnapshotItemInterface $snapshotItem
   *   Information about the content item stored as a snapshot item.
   * @param mixed $object
   *   Content item.
   *
   * @return bool
   *   Returns object if restored references. Otherwise returns NULL.
   */
  public function restoreReferences(SnapshotItemInterface $snapshotItem, &$object): bool;

}
